{% from "webshop/templates/includes/macros.html" import product_image %}

{% macro item_subtotal(item) %}
<div class="text-nowrap">
	{% if item.is_free_item and item.item_booking %}
	{% set item_booking = frappe.get_doc("Item Booking", item.item_booking) %}
	{% set credits = item_booking.get_deducted_credits() %}
	{% if credits % 1 == 0 %}{% set credits = credits | int %}{% endif %}
	{% set credit_unit = _("Credits") if credits > 1 else _("Credit") %}
	<span class="credit-chip">
		<svg style="--icon-stroke: var(--primary)" height="18px" width="18px">
			<use href="#credit-chip"></use>
		</svg>
	</span>
	<span>{{ credits }} {{ credit_unit }}</span>
	{% else %}
	{{ item.get_formatted('amount') }}
	{% endif %}
</div>

{% if item.is_free_item and not item.item_booking %}
<div class="text-success mt-4">
	<span class="free-tag">
		{{ _('Free') }}
	</span>
</div>
{% elif not item.is_free_item %}
<span class="item-rate text-nowrap">
	{{ _('Rate:') }} {{ item.get_formatted('rate') }}
</span>
{% endif %}

<span class="item-unit text-nowrap">
	{{ _(item.uom) }}
</span>
{% endmacro %}

{% for d in doc.items %}
{% set dataAttributes = {
"data-item-code": d.item_code,
"data-item-booking": d.item_booking
} | xmlattr %}
<tr data-name="{{ d.name }}">
	<td style="width: 60%;">
		<div class="d-flex">
			<div class="cart-item-image mr-4">
				{% if d.thumbnail %}
				{{ product_image(d.thumbnail, alt="d.web_item_name", no_border=True) }}
				{% else %}
				<div class="no-image-cart-item">
					{{ frappe.utils.get_abbr(d.web_item_name) or "NA" }}
				</div>
				{% endif %}
			</div>

			<div class="d-flex w-100" style="flex-direction: column;">
				<div class="item-title mb-1 mr-3">
					{{ d.get("web_item_name") or d.item_name }}
				</div>
				<div class="item-subtitle mr-2">
					<a href="{{ d.route }}">{{ d.item_code }}</a>
				</div>

				{% if d.item_booking %}
				{% set item_booking_doc = frappe.db.get_value('Item Booking', d.item_booking, ['starts_on', 'ends_on'], as_dict=True) %}
				<span class="item-subtitle mt-2">
					{{ _("Date") }}: {{ frappe.utils.format_date(item_booking_doc.starts_on) }}
				</span>
				<span class="item-subtitle">
					{{ _("Time", null, "Cart") }}: {{ frappe.utils.format_time(item_booking_doc.starts_on) }} - {{ frappe.utils.format_time(item_booking_doc.ends_on) }}
				</span>
				{% endif %}

				{%- set variant_of = frappe.db.get_value('Item', d.item_code, 'variant_of') %}
				{% if variant_of %}
				<span class="item-subtitle mr-2">
					{{ _('Variant of') }}
					<a href="{{frappe.db.get_value('Website Item', {'item_code': variant_of}, 'route') or '#'}}">
						{{ variant_of }}
					</a>
				</span>
				{% endif %}

				<div class="mt-2 notes">
					<textarea {{ dataAttributes }} class="form-control" rows="2" placeholder="{{ _('Add notes') }}">
							{%- if d.additional_notes %}{{ d.additional_notes }}{% endif -%}
						</textarea>
				</div>
			</div>
		</div>
	</td>

	<!-- Qty column -->
	<td class="text-right" style="width: 25%;">
		<div class="d-flex">
			{% if d.item_booking %}
			<a
				class="modify-booking-btn column-sm-view d-flex"
				{{ dataAttributes }}
				href="{{ d.route }}?date={{ frappe.utils.getdate(item_booking_doc.starts_on) }}"
			>
				{{ _("Modify") }}
			</a>
			{% else %}
			{% set disabled = 'disabled' if (d.is_free_item or d.is_recurring_item) else '' %}
			<div class="input-group number-spinner mt-1 mb-4">
				<button class="input-group-prepend btn btn-md cart-btn" data-dir="dwn" {{ disabled }}>
					{{ '–' if not d.is_free_item else ''}}
				</button>

				<input class="form-control text-center cart-qty" value="{{ d.get_formatted('qty') }}" {{ dataAttributes }}" style="max-width: 70px;" {{ disabled }}>

				<button class="input-group-append btn btn-md cart-btn" data-dir="up" {{ disabled }}>
					{{ '+' if not d.is_free_item else ''}}
				</button>
			</div>
			{% endif %}

			<button class="remove-cart-item d-flex mb-4" {{ dataAttributes }}>
				<span>
					<svg class="icon sm remove-cart-item-logo" width="18" height="18" viewBox="0 0 18 18" xmlns="http://www.w3.org/2000/svg" id="icon-close">
						<path fill-rule="evenodd" clip-rule="evenodd" d="M4.146 11.217a.5.5 0 1 0 .708.708l3.182-3.182 3.181 3.182a.5.5 0 1 0 .708-.708l-3.182-3.18 3.182-3.182a.5.5 0 1 0-.708-.708l-3.18 3.181-3.183-3.182a.5.5 0 0 0-.708.708l3.182 3.182-3.182 3.181z" stroke-width="0"></path>
					</svg>
				</span>
			</button>
		</div>


		<!-- Shown on mobile view, else hidden -->
		{% if cart_settings.enable_checkout or cart_settings.show_price_in_quotation %}
		<div class="text-right sm-item-subtotal">
			{{ item_subtotal(d) }}
		</div>
		{% endif %}
	</td>

	<!-- Subtotal column -->
	{% if cart_settings.enable_checkout or cart_settings.show_price_in_quotation %}
	<td class="text-right item-subtotal column-sm-view w-100">
		{{ item_subtotal(d) }}
	</td>
	{% endif %}
</tr>
{% endfor %}
